/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "parser_yacc.y"

/*
 *   Copyright (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
 *   NOVELL (All rights reserved)
 *   Copyright (c) 2010-2012
 *   Canonical Ltd.
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, contact Canonical, Ltd.
 */

#define YYERROR_VERBOSE 1
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/apparmor.h>

#include <iostream>

/* #define DEBUG */

#include "parser.h"
#include "profile.h"
#include "mount.h"
#include "dbus.h"
#include "af_unix.h"
#include "parser_include.h"
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <linux/capability.h>

#ifndef CAP_AUDIT_WRITE
#define CAP_AUDIT_WRITE 29
#endif
#ifndef CAP_AUDIT_CONTROL
#define CAP_AUDIT_CONTROL 30
#endif
#ifndef CAP_SETFCAP
#define CAP_SETFCAP	     31
#endif
#ifndef CAP_MAC_OVERRIDE
#define CAP_MAC_OVERRIDE     32
#endif

#define CIDR_32 htonl(0xffffffff)
#define CIDR_24 htonl(0xffffff00)
#define CIDR_16 htonl(0xffff0000)
#define CIDR_8  htonl(0xff000000)

/* undefine linux/capability.h CAP_TO_MASK */
#ifdef CAP_TO_MASK
#undef CAP_TO_MASK
#endif

#define CAP_TO_MASK(x) (1ull << (x))

#define EXEC_MODE_EMPTY		0
#define EXEC_MODE_UNSAFE	1
#define EXEC_MODE_SAFE		2

int parser_token = 0;

struct cod_entry *do_file_rule(char *id, int mode, char *link_id, char *nt);
mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      int mode);
mnt_rule *do_pivot_rule(struct cond_entry *old, char *root,
			char *transition);
void add_local_entry(Profile *prof);


#line 158 "parser_yacc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_PARSER_YACC_H_INCLUDED
# define YY_YY_PARSER_YACC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 183 "parser_yacc.y"

	#include "parser.h"
	#include "profile.h"
	#include "mount.h"
	#include "dbus.h"
	#include "signal.h"
	#include "ptrace.h"
	#include "af_unix.h"

#line 203 "parser_yacc.c"

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TOK_ID = 258,                  /* TOK_ID  */
    TOK_CONDID = 259,              /* TOK_CONDID  */
    TOK_CONDLISTID = 260,          /* TOK_CONDLISTID  */
    TOK_CARET = 261,               /* TOK_CARET  */
    TOK_OPEN = 262,                /* TOK_OPEN  */
    TOK_CLOSE = 263,               /* TOK_CLOSE  */
    TOK_MODE = 264,                /* TOK_MODE  */
    TOK_END_OF_RULE = 265,         /* TOK_END_OF_RULE  */
    TOK_EQUALS = 266,              /* TOK_EQUALS  */
    TOK_ARROW = 267,               /* TOK_ARROW  */
    TOK_ADD_ASSIGN = 268,          /* TOK_ADD_ASSIGN  */
    TOK_LE = 269,                  /* TOK_LE  */
    TOK_SET_VAR = 270,             /* TOK_SET_VAR  */
    TOK_BOOL_VAR = 271,            /* TOK_BOOL_VAR  */
    TOK_VALUE = 272,               /* TOK_VALUE  */
    TOK_IF = 273,                  /* TOK_IF  */
    TOK_ELSE = 274,                /* TOK_ELSE  */
    TOK_NOT = 275,                 /* TOK_NOT  */
    TOK_DEFINED = 276,             /* TOK_DEFINED  */
    TOK_CHANGE_PROFILE = 277,      /* TOK_CHANGE_PROFILE  */
    TOK_NETWORK = 278,             /* TOK_NETWORK  */
    TOK_UNIX = 279,                /* TOK_UNIX  */
    TOK_CREATE = 280,              /* TOK_CREATE  */
    TOK_SHUTDOWN = 281,            /* TOK_SHUTDOWN  */
    TOK_ACCEPT = 282,              /* TOK_ACCEPT  */
    TOK_CONNECT = 283,             /* TOK_CONNECT  */
    TOK_LISTEN = 284,              /* TOK_LISTEN  */
    TOK_SETOPT = 285,              /* TOK_SETOPT  */
    TOK_GETOPT = 286,              /* TOK_GETOPT  */
    TOK_SETATTR = 287,             /* TOK_SETATTR  */
    TOK_GETATTR = 288,             /* TOK_GETATTR  */
    TOK_HAT = 289,                 /* TOK_HAT  */
    TOK_UNSAFE = 290,              /* TOK_UNSAFE  */
    TOK_SAFE = 291,                /* TOK_SAFE  */
    TOK_COLON = 292,               /* TOK_COLON  */
    TOK_LINK = 293,                /* TOK_LINK  */
    TOK_OWNER = 294,               /* TOK_OWNER  */
    TOK_OTHER = 295,               /* TOK_OTHER  */
    TOK_SUBSET = 296,              /* TOK_SUBSET  */
    TOK_AUDIT = 297,               /* TOK_AUDIT  */
    TOK_DENY = 298,                /* TOK_DENY  */
    TOK_ALLOW = 299,               /* TOK_ALLOW  */
    TOK_PROFILE = 300,             /* TOK_PROFILE  */
    TOK_SET = 301,                 /* TOK_SET  */
    TOK_ALIAS = 302,               /* TOK_ALIAS  */
    TOK_PTRACE = 303,              /* TOK_PTRACE  */
    TOK_OPENPAREN = 304,           /* TOK_OPENPAREN  */
    TOK_CLOSEPAREN = 305,          /* TOK_CLOSEPAREN  */
    TOK_COMMA = 306,               /* TOK_COMMA  */
    TOK_FILE = 307,                /* TOK_FILE  */
    TOK_MOUNT = 308,               /* TOK_MOUNT  */
    TOK_REMOUNT = 309,             /* TOK_REMOUNT  */
    TOK_UMOUNT = 310,              /* TOK_UMOUNT  */
    TOK_PIVOTROOT = 311,           /* TOK_PIVOTROOT  */
    TOK_IN = 312,                  /* TOK_IN  */
    TOK_DBUS = 313,                /* TOK_DBUS  */
    TOK_SIGNAL = 314,              /* TOK_SIGNAL  */
    TOK_SEND = 315,                /* TOK_SEND  */
    TOK_RECEIVE = 316,             /* TOK_RECEIVE  */
    TOK_BIND = 317,                /* TOK_BIND  */
    TOK_READ = 318,                /* TOK_READ  */
    TOK_WRITE = 319,               /* TOK_WRITE  */
    TOK_EAVESDROP = 320,           /* TOK_EAVESDROP  */
    TOK_PEER = 321,                /* TOK_PEER  */
    TOK_TRACE = 322,               /* TOK_TRACE  */
    TOK_TRACEDBY = 323,            /* TOK_TRACEDBY  */
    TOK_READBY = 324,              /* TOK_READBY  */
    TOK_ABI = 325,                 /* TOK_ABI  */
    TOK_RLIMIT = 326,              /* TOK_RLIMIT  */
    TOK_SOFT_RLIMIT = 327,         /* TOK_SOFT_RLIMIT  */
    TOK_RLIMIT_CPU = 328,          /* TOK_RLIMIT_CPU  */
    TOK_RLIMIT_FSIZE = 329,        /* TOK_RLIMIT_FSIZE  */
    TOK_RLIMIT_DATA = 330,         /* TOK_RLIMIT_DATA  */
    TOK_RLIMIT_STACK = 331,        /* TOK_RLIMIT_STACK  */
    TOK_RLIMIT_CORE = 332,         /* TOK_RLIMIT_CORE  */
    TOK_RLIMIT_RSS = 333,          /* TOK_RLIMIT_RSS  */
    TOK_RLIMIT_NOFILE = 334,       /* TOK_RLIMIT_NOFILE  */
    TOK_RLIMIT_OFILE = 335,        /* TOK_RLIMIT_OFILE  */
    TOK_RLIMIT_AS = 336,           /* TOK_RLIMIT_AS  */
    TOK_RLIMIT_NPROC = 337,        /* TOK_RLIMIT_NPROC  */
    TOK_RLIMIT_MEMLOCK = 338,      /* TOK_RLIMIT_MEMLOCK  */
    TOK_RLIMIT_LOCKS = 339,        /* TOK_RLIMIT_LOCKS  */
    TOK_RLIMIT_SIGPENDING = 340,   /* TOK_RLIMIT_SIGPENDING  */
    TOK_RLIMIT_MSGQUEUE = 341,     /* TOK_RLIMIT_MSGQUEUE  */
    TOK_RLIMIT_NICE = 342,         /* TOK_RLIMIT_NICE  */
    TOK_RLIMIT_RTPRIO = 343,       /* TOK_RLIMIT_RTPRIO  */
    TOK_CAPABILITY = 344,          /* TOK_CAPABILITY  */
    TOK_FLAGS = 345                /* TOK_FLAGS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 193 "parser_yacc.y"

	char *id;
	char *flag_id;
	char *mode;
	struct aa_network_entry *network_entry;
	Profile *prof;
	struct cod_net_entry *net_entry;
	struct cod_entry *user_entry;

	mnt_rule *mnt_entry;
	dbus_rule *dbus_entry;
	signal_rule *signal_entry;
	ptrace_rule *ptrace_entry;
	unix_rule *unix_entry;

	flagvals flags;
	int fmode;
	uint64_t cap;
	unsigned int allowed_protocol;
	char *set_var;
	char *bool_var;
	char *var_val;
	struct value_list *val_list;
	struct cond_entry *cond_entry;
	struct cond_entry_list cond_entry_list;
	int boolean;
	struct prefixes prefix;

#line 339 "parser_yacc.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_YACC_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ID = 3,                     /* TOK_ID  */
  YYSYMBOL_TOK_CONDID = 4,                 /* TOK_CONDID  */
  YYSYMBOL_TOK_CONDLISTID = 5,             /* TOK_CONDLISTID  */
  YYSYMBOL_TOK_CARET = 6,                  /* TOK_CARET  */
  YYSYMBOL_TOK_OPEN = 7,                   /* TOK_OPEN  */
  YYSYMBOL_TOK_CLOSE = 8,                  /* TOK_CLOSE  */
  YYSYMBOL_TOK_MODE = 9,                   /* TOK_MODE  */
  YYSYMBOL_TOK_END_OF_RULE = 10,           /* TOK_END_OF_RULE  */
  YYSYMBOL_TOK_EQUALS = 11,                /* TOK_EQUALS  */
  YYSYMBOL_TOK_ARROW = 12,                 /* TOK_ARROW  */
  YYSYMBOL_TOK_ADD_ASSIGN = 13,            /* TOK_ADD_ASSIGN  */
  YYSYMBOL_TOK_LE = 14,                    /* TOK_LE  */
  YYSYMBOL_TOK_SET_VAR = 15,               /* TOK_SET_VAR  */
  YYSYMBOL_TOK_BOOL_VAR = 16,              /* TOK_BOOL_VAR  */
  YYSYMBOL_TOK_VALUE = 17,                 /* TOK_VALUE  */
  YYSYMBOL_TOK_IF = 18,                    /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 19,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_NOT = 20,                   /* TOK_NOT  */
  YYSYMBOL_TOK_DEFINED = 21,               /* TOK_DEFINED  */
  YYSYMBOL_TOK_CHANGE_PROFILE = 22,        /* TOK_CHANGE_PROFILE  */
  YYSYMBOL_TOK_NETWORK = 23,               /* TOK_NETWORK  */
  YYSYMBOL_TOK_UNIX = 24,                  /* TOK_UNIX  */
  YYSYMBOL_TOK_CREATE = 25,                /* TOK_CREATE  */
  YYSYMBOL_TOK_SHUTDOWN = 26,              /* TOK_SHUTDOWN  */
  YYSYMBOL_TOK_ACCEPT = 27,                /* TOK_ACCEPT  */
  YYSYMBOL_TOK_CONNECT = 28,               /* TOK_CONNECT  */
  YYSYMBOL_TOK_LISTEN = 29,                /* TOK_LISTEN  */
  YYSYMBOL_TOK_SETOPT = 30,                /* TOK_SETOPT  */
  YYSYMBOL_TOK_GETOPT = 31,                /* TOK_GETOPT  */
  YYSYMBOL_TOK_SETATTR = 32,               /* TOK_SETATTR  */
  YYSYMBOL_TOK_GETATTR = 33,               /* TOK_GETATTR  */
  YYSYMBOL_TOK_HAT = 34,                   /* TOK_HAT  */
  YYSYMBOL_TOK_UNSAFE = 35,                /* TOK_UNSAFE  */
  YYSYMBOL_TOK_SAFE = 36,                  /* TOK_SAFE  */
  YYSYMBOL_TOK_COLON = 37,                 /* TOK_COLON  */
  YYSYMBOL_TOK_LINK = 38,                  /* TOK_LINK  */
  YYSYMBOL_TOK_OWNER = 39,                 /* TOK_OWNER  */
  YYSYMBOL_TOK_OTHER = 40,                 /* TOK_OTHER  */
  YYSYMBOL_TOK_SUBSET = 41,                /* TOK_SUBSET  */
  YYSYMBOL_TOK_AUDIT = 42,                 /* TOK_AUDIT  */
  YYSYMBOL_TOK_DENY = 43,                  /* TOK_DENY  */
  YYSYMBOL_TOK_ALLOW = 44,                 /* TOK_ALLOW  */
  YYSYMBOL_TOK_PROFILE = 45,               /* TOK_PROFILE  */
  YYSYMBOL_TOK_SET = 46,                   /* TOK_SET  */
  YYSYMBOL_TOK_ALIAS = 47,                 /* TOK_ALIAS  */
  YYSYMBOL_TOK_PTRACE = 48,                /* TOK_PTRACE  */
  YYSYMBOL_TOK_OPENPAREN = 49,             /* TOK_OPENPAREN  */
  YYSYMBOL_TOK_CLOSEPAREN = 50,            /* TOK_CLOSEPAREN  */
  YYSYMBOL_TOK_COMMA = 51,                 /* TOK_COMMA  */
  YYSYMBOL_TOK_FILE = 52,                  /* TOK_FILE  */
  YYSYMBOL_TOK_MOUNT = 53,                 /* TOK_MOUNT  */
  YYSYMBOL_TOK_REMOUNT = 54,               /* TOK_REMOUNT  */
  YYSYMBOL_TOK_UMOUNT = 55,                /* TOK_UMOUNT  */
  YYSYMBOL_TOK_PIVOTROOT = 56,             /* TOK_PIVOTROOT  */
  YYSYMBOL_TOK_IN = 57,                    /* TOK_IN  */
  YYSYMBOL_TOK_DBUS = 58,                  /* TOK_DBUS  */
  YYSYMBOL_TOK_SIGNAL = 59,                /* TOK_SIGNAL  */
  YYSYMBOL_TOK_SEND = 60,                  /* TOK_SEND  */
  YYSYMBOL_TOK_RECEIVE = 61,               /* TOK_RECEIVE  */
  YYSYMBOL_TOK_BIND = 62,                  /* TOK_BIND  */
  YYSYMBOL_TOK_READ = 63,                  /* TOK_READ  */
  YYSYMBOL_TOK_WRITE = 64,                 /* TOK_WRITE  */
  YYSYMBOL_TOK_EAVESDROP = 65,             /* TOK_EAVESDROP  */
  YYSYMBOL_TOK_PEER = 66,                  /* TOK_PEER  */
  YYSYMBOL_TOK_TRACE = 67,                 /* TOK_TRACE  */
  YYSYMBOL_TOK_TRACEDBY = 68,              /* TOK_TRACEDBY  */
  YYSYMBOL_TOK_READBY = 69,                /* TOK_READBY  */
  YYSYMBOL_TOK_ABI = 70,                   /* TOK_ABI  */
  YYSYMBOL_TOK_RLIMIT = 71,                /* TOK_RLIMIT  */
  YYSYMBOL_TOK_SOFT_RLIMIT = 72,           /* TOK_SOFT_RLIMIT  */
  YYSYMBOL_TOK_RLIMIT_CPU = 73,            /* TOK_RLIMIT_CPU  */
  YYSYMBOL_TOK_RLIMIT_FSIZE = 74,          /* TOK_RLIMIT_FSIZE  */
  YYSYMBOL_TOK_RLIMIT_DATA = 75,           /* TOK_RLIMIT_DATA  */
  YYSYMBOL_TOK_RLIMIT_STACK = 76,          /* TOK_RLIMIT_STACK  */
  YYSYMBOL_TOK_RLIMIT_CORE = 77,           /* TOK_RLIMIT_CORE  */
  YYSYMBOL_TOK_RLIMIT_RSS = 78,            /* TOK_RLIMIT_RSS  */
  YYSYMBOL_TOK_RLIMIT_NOFILE = 79,         /* TOK_RLIMIT_NOFILE  */
  YYSYMBOL_TOK_RLIMIT_OFILE = 80,          /* TOK_RLIMIT_OFILE  */
  YYSYMBOL_TOK_RLIMIT_AS = 81,             /* TOK_RLIMIT_AS  */
  YYSYMBOL_TOK_RLIMIT_NPROC = 82,          /* TOK_RLIMIT_NPROC  */
  YYSYMBOL_TOK_RLIMIT_MEMLOCK = 83,        /* TOK_RLIMIT_MEMLOCK  */
  YYSYMBOL_TOK_RLIMIT_LOCKS = 84,          /* TOK_RLIMIT_LOCKS  */
  YYSYMBOL_TOK_RLIMIT_SIGPENDING = 85,     /* TOK_RLIMIT_SIGPENDING  */
  YYSYMBOL_TOK_RLIMIT_MSGQUEUE = 86,       /* TOK_RLIMIT_MSGQUEUE  */
  YYSYMBOL_TOK_RLIMIT_NICE = 87,           /* TOK_RLIMIT_NICE  */
  YYSYMBOL_TOK_RLIMIT_RTPRIO = 88,         /* TOK_RLIMIT_RTPRIO  */
  YYSYMBOL_TOK_CAPABILITY = 89,            /* TOK_CAPABILITY  */
  YYSYMBOL_TOK_FLAGS = 90,                 /* TOK_FLAGS  */
  YYSYMBOL_YYACCEPT = 91,                  /* $accept  */
  YYSYMBOL_list = 92,                      /* list  */
  YYSYMBOL_profilelist = 93,               /* profilelist  */
  YYSYMBOL_opt_profile_flag = 94,          /* opt_profile_flag  */
  YYSYMBOL_opt_id = 95,                    /* opt_id  */
  YYSYMBOL_opt_id_or_var = 96,             /* opt_id_or_var  */
  YYSYMBOL_profile_base = 97,              /* profile_base  */
  YYSYMBOL_profile = 98,                   /* profile  */
  YYSYMBOL_local_profile = 99,             /* local_profile  */
  YYSYMBOL_hat = 100,                      /* hat  */
  YYSYMBOL_preamble = 101,                 /* preamble  */
  YYSYMBOL_alias = 102,                    /* alias  */
  YYSYMBOL_varassign = 103,                /* varassign  */
  YYSYMBOL_valuelist = 104,                /* valuelist  */
  YYSYMBOL_flags = 105,                    /* flags  */
  YYSYMBOL_opt_flags = 106,                /* opt_flags  */
  YYSYMBOL_flagvals = 107,                 /* flagvals  */
  YYSYMBOL_flagval = 108,                  /* flagval  */
  YYSYMBOL_opt_subset_flag = 109,          /* opt_subset_flag  */
  YYSYMBOL_opt_audit_flag = 110,           /* opt_audit_flag  */
  YYSYMBOL_opt_owner_flag = 111,           /* opt_owner_flag  */
  YYSYMBOL_opt_perm_mode = 112,            /* opt_perm_mode  */
  YYSYMBOL_opt_prefix = 113,               /* opt_prefix  */
  YYSYMBOL_rules = 114,                    /* rules  */
  YYSYMBOL_cond_rule = 115,                /* cond_rule  */
  YYSYMBOL_expr = 116,                     /* expr  */
  YYSYMBOL_id_or_var = 117,                /* id_or_var  */
  YYSYMBOL_opt_target = 118,               /* opt_target  */
  YYSYMBOL_opt_named_transition = 119,     /* opt_named_transition  */
  YYSYMBOL_rule = 120,                     /* rule  */
  YYSYMBOL_abi_rule = 121,                 /* abi_rule  */
  YYSYMBOL_opt_exec_mode = 122,            /* opt_exec_mode  */
  YYSYMBOL_opt_file = 123,                 /* opt_file  */
  YYSYMBOL_frule = 124,                    /* frule  */
  YYSYMBOL_file_rule = 125,                /* file_rule  */
  YYSYMBOL_file_rule_tail = 126,           /* file_rule_tail  */
  YYSYMBOL_link_rule = 127,                /* link_rule  */
  YYSYMBOL_network_rule = 128,             /* network_rule  */
  YYSYMBOL_cond = 129,                     /* cond  */
  YYSYMBOL_opt_conds = 130,                /* opt_conds  */
  YYSYMBOL_cond_list = 131,                /* cond_list  */
  YYSYMBOL_opt_cond_list = 132,            /* opt_cond_list  */
  YYSYMBOL_mnt_rule = 133,                 /* mnt_rule  */
  YYSYMBOL_dbus_perm = 134,                /* dbus_perm  */
  YYSYMBOL_dbus_perms = 135,               /* dbus_perms  */
  YYSYMBOL_opt_dbus_perm = 136,            /* opt_dbus_perm  */
  YYSYMBOL_dbus_rule = 137,                /* dbus_rule  */
  YYSYMBOL_net_perm = 138,                 /* net_perm  */
  YYSYMBOL_net_perms = 139,                /* net_perms  */
  YYSYMBOL_opt_net_perm = 140,             /* opt_net_perm  */
  YYSYMBOL_unix_rule = 141,                /* unix_rule  */
  YYSYMBOL_signal_perm = 142,              /* signal_perm  */
  YYSYMBOL_signal_perms = 143,             /* signal_perms  */
  YYSYMBOL_opt_signal_perm = 144,          /* opt_signal_perm  */
  YYSYMBOL_signal_rule = 145,              /* signal_rule  */
  YYSYMBOL_ptrace_perm = 146,              /* ptrace_perm  */
  YYSYMBOL_ptrace_perms = 147,             /* ptrace_perms  */
  YYSYMBOL_opt_ptrace_perm = 148,          /* opt_ptrace_perm  */
  YYSYMBOL_ptrace_rule = 149,              /* ptrace_rule  */
  YYSYMBOL_hat_start = 150,                /* hat_start  */
  YYSYMBOL_file_mode = 151,                /* file_mode  */
  YYSYMBOL_change_profile = 152,           /* change_profile  */
  YYSYMBOL_capability = 153,               /* capability  */
  YYSYMBOL_caps = 154                      /* caps  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   338

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  91
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  64
/* YYNRULES -- Number of rules.  */
#define YYNRULES  176
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  273

#define YYMAXUTOK   345


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   288,   288,   291,   293,   299,   300,   301,   303,   304,
     306,   307,   309,   363,   380,   391,   401,   402,   403,   404,
     406,   414,   441,   469,   489,   499,   510,   516,   517,   525,
     530,   552,   557,   589,   590,   591,   593,   594,   596,   597,
     598,   600,   601,   602,   604,   611,   620,   622,   650,   685,
     733,   750,   766,   782,   798,   814,   834,   853,   862,   872,
     878,   977,   989,  1003,  1017,  1022,  1037,  1047,  1057,  1058,
    1060,  1061,  1063,  1064,  1069,  1070,  1072,  1078,  1079,  1080,
    1082,  1083,  1085,  1090,  1108,  1119,  1122,  1137,  1146,  1156,
    1171,  1184,  1195,  1209,  1219,  1228,  1229,  1235,  1241,  1242,
    1244,  1249,  1254,  1259,  1264,  1269,  1287,  1288,  1289,  1290,
    1291,  1292,  1293,  1299,  1300,  1301,  1303,  1304,  1305,  1307,
    1323,  1357,  1358,  1359,  1360,  1361,  1362,  1363,  1364,  1365,
    1366,  1367,  1368,  1369,  1370,  1371,  1377,  1378,  1379,  1381,
    1382,  1383,  1385,  1401,  1415,  1416,  1417,  1418,  1419,  1425,
    1426,  1427,  1429,  1430,  1431,  1433,  1439,  1457,  1458,  1459,
    1460,  1461,  1462,  1468,  1469,  1470,  1472,  1473,  1474,  1476,
    1482,  1483,  1485,  1493,  1540,  1549,  1550
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ID", "TOK_CONDID",
  "TOK_CONDLISTID", "TOK_CARET", "TOK_OPEN", "TOK_CLOSE", "TOK_MODE",
  "TOK_END_OF_RULE", "TOK_EQUALS", "TOK_ARROW", "TOK_ADD_ASSIGN", "TOK_LE",
  "TOK_SET_VAR", "TOK_BOOL_VAR", "TOK_VALUE", "TOK_IF", "TOK_ELSE",
  "TOK_NOT", "TOK_DEFINED", "TOK_CHANGE_PROFILE", "TOK_NETWORK",
  "TOK_UNIX", "TOK_CREATE", "TOK_SHUTDOWN", "TOK_ACCEPT", "TOK_CONNECT",
  "TOK_LISTEN", "TOK_SETOPT", "TOK_GETOPT", "TOK_SETATTR", "TOK_GETATTR",
  "TOK_HAT", "TOK_UNSAFE", "TOK_SAFE", "TOK_COLON", "TOK_LINK",
  "TOK_OWNER", "TOK_OTHER", "TOK_SUBSET", "TOK_AUDIT", "TOK_DENY",
  "TOK_ALLOW", "TOK_PROFILE", "TOK_SET", "TOK_ALIAS", "TOK_PTRACE",
  "TOK_OPENPAREN", "TOK_CLOSEPAREN", "TOK_COMMA", "TOK_FILE", "TOK_MOUNT",
  "TOK_REMOUNT", "TOK_UMOUNT", "TOK_PIVOTROOT", "TOK_IN", "TOK_DBUS",
  "TOK_SIGNAL", "TOK_SEND", "TOK_RECEIVE", "TOK_BIND", "TOK_READ",
  "TOK_WRITE", "TOK_EAVESDROP", "TOK_PEER", "TOK_TRACE", "TOK_TRACEDBY",
  "TOK_READBY", "TOK_ABI", "TOK_RLIMIT", "TOK_SOFT_RLIMIT",
  "TOK_RLIMIT_CPU", "TOK_RLIMIT_FSIZE", "TOK_RLIMIT_DATA",
  "TOK_RLIMIT_STACK", "TOK_RLIMIT_CORE", "TOK_RLIMIT_RSS",
  "TOK_RLIMIT_NOFILE", "TOK_RLIMIT_OFILE", "TOK_RLIMIT_AS",
  "TOK_RLIMIT_NPROC", "TOK_RLIMIT_MEMLOCK", "TOK_RLIMIT_LOCKS",
  "TOK_RLIMIT_SIGPENDING", "TOK_RLIMIT_MSGQUEUE", "TOK_RLIMIT_NICE",
  "TOK_RLIMIT_RTPRIO", "TOK_CAPABILITY", "TOK_FLAGS", "$accept", "list",
  "profilelist", "opt_profile_flag", "opt_id", "opt_id_or_var",
  "profile_base", "profile", "local_profile", "hat", "preamble", "alias",
  "varassign", "valuelist", "flags", "opt_flags", "flagvals", "flagval",
  "opt_subset_flag", "opt_audit_flag", "opt_owner_flag", "opt_perm_mode",
  "opt_prefix", "rules", "cond_rule", "expr", "id_or_var", "opt_target",
  "opt_named_transition", "rule", "abi_rule", "opt_exec_mode", "opt_file",
  "frule", "file_rule", "file_rule_tail", "link_rule", "network_rule",
  "cond", "opt_conds", "cond_list", "opt_cond_list", "mnt_rule",
  "dbus_perm", "dbus_perms", "opt_dbus_perm", "dbus_rule", "net_perm",
  "net_perms", "opt_net_perm", "unix_rule", "signal_perm", "signal_perms",
  "opt_signal_perm", "signal_rule", "ptrace_perm", "ptrace_perms",
  "opt_ptrace_perm", "ptrace_rule", "hat_start", "file_mode",
  "change_profile", "capability", "caps", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345
};
#endif

#define YYPACT_NINF (-160)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-28)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -160,    81,     7,  -160,   169,   104,    21,    95,     5,  -160,
    -160,  -160,    93,    93,   120,   117,   140,  -160,  -160,  -160,
     154,  -160,  -160,  -160,   159,   159,  -160,   176,  -160,    29,
    -160,  -160,   190,  -160,  -160,    16,  -160,  -160,   193,   215,
     175,  -160,  -160,   206,     1,  -160,    -1,  -160,  -160,   133,
    -160,   154,   157,  -160,  -160,   103,     3,  -160,  -160,   154,
    -160,  -160,  -160,   133,   149,   218,  -160,   233,  -160,  -160,
     163,  -160,   170,    27,   224,     4,    92,   227,  -160,  -160,
    -160,  -160,   109,   274,  -160,  -160,   170,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,   225,  -160,  -160,  -160,    30,  -160,  -160,   235,
     122,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,    29,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,   204,   204,   204,   204,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,   142,
     286,  -160,    61,   223,  -160,  -160,   230,   250,  -160,   184,
     214,   231,    71,    24,    -5,   174,  -160,   251,   252,   247,
     127,   214,   254,   123,  -160,  -160,  -160,   255,  -160,     4,
     246,   235,    29,   257,  -160,  -160,   249,  -160,   258,  -160,
     260,    29,  -160,    99,  -160,  -160,    68,   219,  -160,  -160,
    -160,  -160,    29,   262,  -160,   134,  -160,   280,  -160,   166,
    -160,  -160,    87,    29,   112,   282,  -160,  -160,  -160,   244,
    -160,   284,  -160,  -160,    93,    93,   217,  -160,  -160,  -160,
    -160,  -160,  -160,   287,   230,  -160,  -160,  -160,  -160,  -160,
      23,    43,   288,  -160,   289,    78,    13,  -160,  -160,  -160,
    -160,  -160,  -160
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      16,     0,     3,     1,     0,     0,     0,     0,     2,    17,
      18,    19,     0,     0,     0,     0,     0,   170,   171,     6,
       0,     4,     7,    24,    21,    22,    23,     0,    76,    10,
      13,    25,     0,    68,    69,    26,    11,    20,     0,     0,
       0,    28,    45,     0,    36,    32,     0,    31,    12,     0,
      37,     0,     0,    58,    57,    41,    80,    59,    46,     0,
      29,    30,    65,     0,     0,     0,    14,     0,    43,    42,
      38,    45,    77,     0,   139,    33,   166,    81,    95,    95,
      95,    95,   116,   152,   175,    47,    77,    74,    75,    49,
      50,    51,    54,    52,    53,    55,    56,    15,    64,    66,
      67,    45,     0,    39,    40,    44,    36,    78,    79,     8,
       0,    89,   135,   120,   121,   126,   124,   125,   123,   130,
     129,   128,   127,   136,   131,   132,   122,   133,   134,   140,
      95,    35,    34,     0,   162,   156,   163,   159,   160,   157,
     158,   161,   167,    95,    84,     8,     8,     8,     8,   112,
     105,   113,   107,   108,   106,   109,   110,   111,   117,    95,
     148,   143,   149,   144,   145,   146,   147,   153,    95,     0,
       0,    85,    36,     0,    48,     9,    72,     0,    90,     0,
      98,     0,     0,     0,     0,     0,    96,     0,     0,    70,
       0,    98,     0,     0,   176,   174,   172,     0,    86,    33,
      61,     8,     0,     0,    91,   141,     0,   137,     0,    99,
       0,     0,   168,     0,   164,   169,     0,     0,   100,    95,
     102,   103,     0,     0,   118,     0,   114,     0,   154,     0,
     150,   155,    72,     0,     0,     0,    73,   173,   138,     0,
     142,     0,   165,    92,     0,     0,     0,    71,   104,   115,
     119,   151,    87,     0,    72,    45,    63,    60,    95,    88,
       0,     0,     0,    82,     0,    36,     0,    93,    94,   101,
      83,    62,    97
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -160,  -160,  -160,  -160,  -133,  -160,   -30,  -160,  -160,  -160,
    -160,  -160,  -160,   -13,  -160,  -160,  -160,   256,    97,  -160,
    -160,  -160,  -160,   -70,    66,   240,  -128,  -160,  -143,  -160,
     304,   221,  -160,  -160,  -160,  -160,  -160,  -160,  -160,   -77,
    -160,   125,  -160,  -112,  -160,  -160,  -160,   -92,  -160,  -160,
    -160,  -159,  -160,  -160,  -160,   -85,  -160,  -160,  -160,   300,
     124,  -160,  -160,  -160
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     8,    20,   176,    35,    30,    21,    53,    54,
       2,     9,    10,    24,    39,    40,    46,    47,   133,    55,
     105,    70,    56,    44,    57,    65,    36,   223,   203,    85,
      58,   109,    86,   198,    87,   171,    88,    89,   186,   145,
     209,   210,    90,   158,   190,   159,    91,   129,   179,   130,
      92,   167,   192,   168,    93,   142,   182,   143,    94,    59,
     199,    95,    96,   169
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      25,   106,   146,   147,   148,   181,   216,    17,    -5,    48,
      71,    17,   185,   187,   188,   189,    45,   184,   131,    49,
      38,    66,     4,     5,    15,    72,    73,    74,   184,    97,
     110,   172,    33,   230,   215,    18,    17,   111,   174,    18,
      31,    75,   197,    50,    34,   132,    51,    52,    49,    60,
      19,    76,   217,   180,     6,    77,    78,    79,    80,    81,
      31,    82,    83,   272,    18,   -27,   183,    17,   235,   200,
     251,     7,    50,   267,   236,    51,    52,     7,   226,    49,
     134,     3,   191,   241,    17,   243,   271,   207,   135,   253,
      33,   193,    84,   268,   247,    18,    49,   214,    16,   202,
       7,   134,    34,    50,   252,   254,    51,    52,   134,   135,
      23,   264,    18,   249,   238,    14,   135,   244,   149,   255,
      50,   212,   213,    51,    52,   177,   150,   184,   242,    27,
      49,     7,   178,   231,   137,   138,   149,    26,   139,   140,
     141,   136,   246,   149,   150,   194,    68,    69,     7,    62,
      28,   150,   195,    63,    64,   137,   138,    29,   151,   139,
     140,   141,   137,   138,    99,   100,   139,   140,   141,   152,
     153,   154,   155,   156,   157,   160,    31,   224,   225,    32,
      12,   266,    13,   161,   218,   265,   219,   152,   153,   154,
     155,   156,   157,   112,   152,   153,   154,   155,   156,   157,
      37,   113,   103,   104,    41,   107,   108,   175,   184,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   184,   208,
     262,   184,    42,    45,    43,   101,   163,   164,    67,   165,
     166,   260,   261,   112,   205,   206,   102,   144,   175,   173,
     201,   113,   202,   211,   124,   125,   126,   127,   128,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   112,   222,
     204,   220,   221,   160,   196,   234,   113,   237,   245,   239,
     240,   161,   248,   123,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   160,   124,   125,   126,   127,   128,    33,
     250,   161,   257,   258,   259,   196,   233,   263,   269,   270,
     256,    34,    61,    98,   228,   229,    11,   170,    22,   124,
     125,   126,   127,   128,   163,   164,   227,   165,   166,     0,
       0,   232,     0,   162,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   163,   164,     0,   165,   166
};

static const yytype_int16 yycheck[] =
{
      13,    71,    79,    80,    81,   133,    11,     6,     3,     8,
       7,     6,   145,   146,   147,   148,    17,     4,    14,    18,
       4,    51,    15,    16,     3,    22,    23,    24,     4,    59,
       3,   101,     3,   192,    10,    34,     6,    10,     8,    34,
      17,    38,   170,    42,    15,    41,    45,    46,    18,    50,
      45,    48,    57,   130,    47,    52,    53,    54,    55,    56,
      17,    58,    59,    50,    34,    49,   143,     6,   201,     8,
     229,    70,    42,    50,   202,    45,    46,    70,   190,    18,
       9,     0,   159,   211,     6,    17,     8,   179,    17,   232,
       3,   168,    89,    50,   222,    34,    18,   182,     3,    12,
      70,     9,    15,    42,   232,   233,    45,    46,     9,    17,
      17,   254,    34,   225,   206,    11,    17,    49,     9,     7,
      42,    50,    51,    45,    46,     3,    17,     4,   213,    12,
      18,    70,    10,    10,    63,    64,     9,    17,    67,    68,
      69,    49,   219,     9,    17,     3,    43,    44,    70,    16,
      10,    17,    10,    20,    21,    63,    64,     3,    49,    67,
      68,    69,    63,    64,    15,    16,    67,    68,    69,    60,
      61,    62,    63,    64,    65,     9,    17,    50,    51,     3,
      11,   258,    13,    17,    10,   255,    12,    60,    61,    62,
      63,    64,    65,     9,    60,    61,    62,    63,    64,    65,
      10,    17,    39,    40,    11,    35,    36,     3,     4,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     4,     5,
       3,     4,     7,    17,    49,     7,    60,    61,    71,    63,
      64,   244,   245,     9,    50,    51,     3,    10,     3,    14,
      17,    17,    12,    12,    60,    61,    62,    63,    64,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     9,    12,
      10,    10,    10,     9,     9,    19,    17,    10,    49,    11,
      10,    17,    10,    49,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     9,    60,    61,    62,    63,    64,     3,
      10,    17,    10,    49,    10,     9,   199,    10,    10,    10,
     234,    15,    46,    63,    50,    51,     2,    86,     8,    60,
      61,    62,    63,    64,    60,    61,   191,    63,    64,    -1,
      -1,   197,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    63,    64
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    92,   101,     0,    15,    16,    47,    70,    93,   102,
     103,   121,    11,    13,    11,     3,     3,     6,    34,    45,
      94,    98,   150,    17,   104,   104,    17,    12,    10,     3,
      97,    17,     3,     3,    15,    96,   117,    10,     4,   105,
     106,    11,     7,    49,   114,    17,   107,   108,     8,    18,
      42,    45,    46,    99,   100,   110,   113,   115,   121,   150,
      50,   108,    16,    20,    21,   116,    97,    71,    43,    44,
     112,     7,    22,    23,    24,    38,    48,    52,    53,    54,
      55,    56,    58,    59,    89,   120,   123,   125,   127,   128,
     133,   137,   141,   145,   149,   152,   153,    97,   116,    15,
      16,     7,     3,    39,    40,   111,   114,    35,    36,   122,
       3,    10,     9,    17,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    49,    60,    61,    62,    63,    64,   138,
     140,    14,    41,   109,     9,    17,    49,    63,    64,    67,
      68,    69,   146,   148,    10,   130,   130,   130,   130,     9,
      17,    49,    60,    61,    62,    63,    64,    65,   134,   136,
       9,    17,    49,    60,    61,    63,    64,   142,   144,   154,
     122,   126,   114,    14,     8,     3,    95,     3,    10,   139,
     130,   117,   147,   130,     4,    95,   129,    95,    95,    95,
     135,   130,   143,   130,     3,    10,     9,   117,   124,   151,
       8,    17,    12,   119,    10,    50,    51,   138,     5,   131,
     132,    12,    50,    51,   146,    10,    11,    57,    10,    12,
      10,    10,    12,   118,    50,    51,   134,   132,    50,    51,
     142,    10,   151,   109,    19,    95,   117,    10,   138,    11,
      10,   117,   146,    17,    49,    49,   130,   117,    10,   134,
      10,   142,   117,   119,   117,     7,   115,    10,    49,    10,
     104,   104,     3,    10,   119,   114,   130,    50,    50,    10,
      10,     8,    50
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    91,    92,    93,    93,    94,    94,    94,    95,    95,
      96,    96,    97,    98,    99,   100,   101,   101,   101,   101,
     102,   103,   103,   103,   104,   104,   105,   106,   106,   105,
     107,   107,   108,   109,   109,   109,   110,   110,   111,   111,
     111,   112,   112,   112,   113,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   115,   115,   115,   116,   116,   116,   116,   117,   117,
     118,   118,   119,   119,   120,   120,   121,   122,   122,   122,
     123,   123,   124,   124,   125,   125,   126,   126,   127,   128,
     128,   128,   129,   129,   129,   130,   130,   131,   132,   132,
     133,   133,   133,   133,   133,   134,   134,   134,   134,   134,
     134,   134,   134,   135,   135,   135,   136,   136,   136,   137,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   139,   139,   139,   140,
     140,   140,   141,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   144,   144,   144,   145,   146,   146,   146,   146,
     146,   146,   146,   147,   147,   147,   148,   148,   148,   149,
     150,   150,   151,   152,   153,   154,   154
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     1,     1,     0,     1,
       0,     1,     6,     2,     2,     2,     0,     2,     2,     2,
       5,     3,     3,     3,     1,     2,     0,     0,     2,     4,
       2,     1,     1,     0,     1,     1,     0,     1,     0,     1,
       1,     0,     1,     1,     3,     0,     2,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       8,     5,     9,     7,     2,     1,     2,     2,     1,     1,
       0,     2,     0,     2,     1,     1,     3,     0,     1,     1,
       0,     1,     4,     5,     2,     2,     2,     4,     6,     2,
       3,     4,     3,     5,     5,     0,     2,     5,     0,     1,
       4,     7,     4,     4,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     3,     0,     1,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     3,     0,
       1,     3,     5,     1,     1,     1,     1,     1,     1,     0,
       2,     3,     0,     1,     3,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     3,     0,     1,     3,     4,
       1,     1,     1,     5,     3,     0,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 289 "parser_yacc.y"
        { /* nothing */ }
#line 1723 "parser_yacc.c"
    break;

  case 3:
#line 291 "parser_yacc.y"
                { /* nothing */ }
#line 1729 "parser_yacc.c"
    break;

  case 4:
#line 294 "parser_yacc.y"
        {
		PDEBUG("Matched: list profile\n");
		add_to_list((yyvsp[0].prof));
	}
#line 1738 "parser_yacc.c"
    break;

  case 5:
#line 299 "parser_yacc.y"
                  { /* nothing */ (yyval.boolean) = 0; }
#line 1744 "parser_yacc.c"
    break;

  case 6:
#line 300 "parser_yacc.y"
                      { (yyval.boolean) = 1; }
#line 1750 "parser_yacc.c"
    break;

  case 7:
#line 301 "parser_yacc.y"
                    { (yyval.boolean) = 2; }
#line 1756 "parser_yacc.c"
    break;

  case 8:
#line 303 "parser_yacc.y"
        { /* nothing */ (yyval.id) = NULL; }
#line 1762 "parser_yacc.c"
    break;

  case 9:
#line 304 "parser_yacc.y"
                 { (yyval.id) = (yyvsp[0].id); }
#line 1768 "parser_yacc.c"
    break;

  case 10:
#line 306 "parser_yacc.y"
               { /* nothing */ (yyval.id) = NULL; }
#line 1774 "parser_yacc.c"
    break;

  case 11:
#line 307 "parser_yacc.y"
                    { (yyval.id) = (yyvsp[0].id); }
#line 1780 "parser_yacc.c"
    break;

  case 12:
#line 310 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[-1].prof);
		bool self_stack = false;

		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		parse_label(&self_stack, &prof->ns, &prof->name, (yyvsp[-5].id), true);
		free((yyvsp[-5].id));

		if (self_stack) {
			yyerror(_("Profile names must begin with a '/' or a namespace"));
		}

		/* Honor the --namespace-string command line option */
		if (profile_ns) {
			/**
			 * Print warning if the profile specified a namespace
			 * different than the one specified with the
			 * --namespace-string command line option
			 */
			if (prof->ns && strcmp(prof->ns, profile_ns))
				pwarn("%s: -n %s overriding policy specified namespace :%s:\n",
				      progname, profile_ns, prof->ns);

			free(prof->ns);
			prof->ns = strdup(profile_ns);
			if (!prof->ns)
				yyerror(_("Memory allocation error."));
		}

		prof->attachment = (yyvsp[-4].id);
		if ((yyvsp[-4].id) && !((yyvsp[-4].id)[0] == '/' || strncmp((yyvsp[-4].id), "@{", 2) == 0))
			yyerror(_("Profile attachment must begin with a '/' or variable."));
		prof->flags = (yyvsp[-3].flags);
		if (force_complain && kernel_abi_version == 5)
			/* newer abis encode force complain as part of the
			 * header
			 */
			prof->flags.complain = 1;

		post_process_file_entries(prof);
		post_process_rule_entries(prof);
		PDEBUG("%s: flags='%s%s'\n",
		       (yyvsp[-4].id),
		       prof->flags.complain ? "complain, " : "",
		       prof->flags.audit ? "audit" : "");

		(yyval.prof) = prof;

	}
#line 1837 "parser_yacc.c"
    break;

  case 13:
#line 364 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof)->ns)
			PDEBUG("Matched: :%s://%s { ... }\n", (yyvsp[0].prof)->ns, (yyvsp[0].prof)->name);
		else
			PDEBUG("Matched: %s { ... }\n", (yyvsp[0].prof)->name);

		if ((yyvsp[0].prof)->name[0] != '/' && !((yyvsp[-1].boolean) || (yyvsp[0].prof)->ns))
			yyerror(_("Profile names must begin with a '/', namespace or keyword 'profile' or 'hat'."));

		if ((yyvsp[-1].boolean) == 2)
			prof->flags.hat = 1;
		(yyval.prof) = prof;
	}
#line 1857 "parser_yacc.c"
    break;

  case 14:
#line 381 "parser_yacc.y"
        {

		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof))
			PDEBUG("Matched: local profile %s { ... }\n", prof->name);
		prof->local = 1;
		(yyval.prof) = prof;
	}
#line 1871 "parser_yacc.c"
    break;

  case 15:
#line 392 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[0].prof);
		if ((yyvsp[0].prof))
			PDEBUG("Matched: hat %s { ... }\n", prof->name);

		prof->flags.hat = 1;
		(yyval.prof) = prof;
	}
#line 1884 "parser_yacc.c"
    break;

  case 16:
#line 401 "parser_yacc.y"
          { /* nothing */ }
#line 1890 "parser_yacc.c"
    break;

  case 17:
#line 402 "parser_yacc.y"
                         { /* nothing */ }
#line 1896 "parser_yacc.c"
    break;

  case 18:
#line 403 "parser_yacc.y"
                             { /* nothing */ }
#line 1902 "parser_yacc.c"
    break;

  case 19:
#line 404 "parser_yacc.y"
                            { /* nothing */ }
#line 1908 "parser_yacc.c"
    break;

  case 20:
#line 407 "parser_yacc.y"
        {
		if (!new_alias((yyvsp[-3].id), (yyvsp[-1].id)))
			yyerror(_("Failed to create alias %s -> %s\n"), (yyvsp[-3].id), (yyvsp[-1].id));
		free((yyvsp[-3].id));
		free((yyvsp[-1].id));
	}
#line 1919 "parser_yacc.c"
    break;

  case 21:
#line 415 "parser_yacc.y"
        {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: set assignment for (%s)\n", (yyvsp[-2].set_var));
		err = new_set_var(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was previously declared", (yyvsp[-2].set_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1949 "parser_yacc.c"
    break;

  case 22:
#line 442 "parser_yacc.y"
        {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: additive assignment for (%s)\n", (yyvsp[-2].set_var));
		/* do the first one outside the loop, subsequent
		 * failures are indicative of symtab failures */
		err = add_set_value(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was not previously declared, but is being assigned additional values", (yyvsp[-2].set_var));
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1980 "parser_yacc.c"
    break;

  case 23:
#line 470 "parser_yacc.y"
        {
		int boolean, err;
		char *var_name = process_var((yyvsp[-2].bool_var));
		PDEBUG("Matched: boolean assignment (%s) to %s\n", (yyvsp[-2].bool_var), (yyvsp[0].var_val));
		boolean = str_to_boolean((yyvsp[0].var_val));
		if (boolean == -1) {
			yyerror("Invalid boolean assignment for (%s): %s is not true or false",
				(yyvsp[-2].bool_var), (yyvsp[0].var_val));
		}
		err = add_boolean_var(var_name, boolean);
		free(var_name);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[-2].bool_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		free((yyvsp[-2].bool_var));
		free((yyvsp[0].var_val));
	}
#line 2003 "parser_yacc.c"
    break;

  case 24:
#line 490 "parser_yacc.y"
        {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[0].var_val));

		(yyval.val_list) = val;
	}
#line 2016 "parser_yacc.c"
    break;

  case 25:
#line 500 "parser_yacc.y"
        {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value list\n");

		list_append((yyvsp[-1].val_list), val);
		(yyval.val_list) = (yyvsp[-1].val_list);
	}
#line 2030 "parser_yacc.c"
    break;

  case 26:
#line 510 "parser_yacc.y"
        { /* nothing */
	flagvals fv = { 0, 0, 0, 0 };

		(yyval.flags) = fv;
	}
#line 2040 "parser_yacc.c"
    break;

  case 27:
#line 516 "parser_yacc.y"
           { /* nothing */ (yyval.boolean) = 0; }
#line 2046 "parser_yacc.c"
    break;

  case 28:
#line 518 "parser_yacc.y"
        {
		if (strcmp((yyvsp[-1].id), "flags") != 0)
			yyerror("expected flags= got %s=", (yyvsp[-1].id));
		free((yyvsp[-1].id));
		(yyval.boolean) = 1;
	}
#line 2057 "parser_yacc.c"
    break;

  case 29:
#line 526 "parser_yacc.y"
        {
		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 2065 "parser_yacc.c"
    break;

  case 30:
#line 531 "parser_yacc.y"
        {
		(yyvsp[-1].flags).complain = (yyvsp[-1].flags).complain || (yyvsp[0].flags).complain;
		(yyvsp[-1].flags).audit = (yyvsp[-1].flags).audit || (yyvsp[0].flags).audit;
		(yyvsp[-1].flags).path = (yyvsp[-1].flags).path | (yyvsp[0].flags).path;
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_REL | PATH_NS_REL)) ==
		    (PATH_CHROOT_REL | PATH_NS_REL))
			yyerror(_("Profile flag chroot_relative conflicts with namespace_relative"));

		if (((yyvsp[-1].flags).path & (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED)) ==
		    (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED))
			yyerror(_("Profile flag mediate_deleted conflicts with delegate_deleted"));
		if (((yyvsp[-1].flags).path & (PATH_ATTACH | PATH_NO_ATTACH)) ==
		    (PATH_ATTACH | PATH_NO_ATTACH))
			yyerror(_("Profile flag attach_disconnected conflicts with no_attach_disconnected"));
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH)) ==
		    (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH))
			yyerror(_("Profile flag chroot_attach conflicts with chroot_no_attach"));

		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 2090 "parser_yacc.c"
    break;

  case 31:
#line 553 "parser_yacc.y"
        {
		(yyval.flags) = (yyvsp[0].flags);
	}
#line 2098 "parser_yacc.c"
    break;

  case 32:
#line 558 "parser_yacc.y"
        {
		flagvals fv = { 0, 0, 0, 0 };
		if (strcmp((yyvsp[0].var_val), "debug") == 0) {
			yyerror(_("Profile flag 'debug' is no longer valid."));
		} else if (strcmp((yyvsp[0].var_val), "complain") == 0) {
			fv.complain = 1;
		} else if (strcmp((yyvsp[0].var_val), "audit") == 0) {
			fv.audit = 1;
		} else if (strcmp((yyvsp[0].var_val), "chroot_relative") == 0) {
			fv.path |= PATH_CHROOT_REL;
		} else if (strcmp((yyvsp[0].var_val), "namespace_relative") == 0) {
			fv.path |= PATH_NS_REL;
		} else if (strcmp((yyvsp[0].var_val), "mediate_deleted") == 0) {
			fv.path |= PATH_MEDIATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "delegate_deleted") == 0) {
			fv.path |= PATH_DELEGATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "attach_disconnected") == 0) {
			fv.path |= PATH_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "no_attach_disconnected") == 0) {
			fv.path |= PATH_NO_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_attach") == 0) {
			fv.path |= PATH_CHROOT_NSATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_no_attach") == 0) {
			fv.path |= PATH_CHROOT_NO_ATTACH;
		} else {
			yyerror(_("Invalid profile flag: %s."), (yyvsp[0].var_val));
		}
		free((yyvsp[0].var_val));
		(yyval.flags) = fv;
	}
#line 2133 "parser_yacc.c"
    break;

  case 33:
#line 589 "parser_yacc.y"
                 { /* nothing */ (yyval.boolean) = 0; }
#line 2139 "parser_yacc.c"
    break;

  case 34:
#line 590 "parser_yacc.y"
                     { (yyval.boolean) = 1; }
#line 2145 "parser_yacc.c"
    break;

  case 35:
#line 591 "parser_yacc.y"
                 { (yyval.boolean) = 1; }
#line 2151 "parser_yacc.c"
    break;

  case 36:
#line 593 "parser_yacc.y"
                { /* nothing */ (yyval.boolean) = 0; }
#line 2157 "parser_yacc.c"
    break;

  case 37:
#line 594 "parser_yacc.y"
                    { (yyval.boolean) = 1; }
#line 2163 "parser_yacc.c"
    break;

  case 38:
#line 596 "parser_yacc.y"
                { /* nothing */ (yyval.boolean) = 0; }
#line 2169 "parser_yacc.c"
    break;

  case 39:
#line 597 "parser_yacc.y"
                    { (yyval.boolean) = 1; }
#line 2175 "parser_yacc.c"
    break;

  case 40:
#line 598 "parser_yacc.y"
                    { (yyval.boolean) = 2; }
#line 2181 "parser_yacc.c"
    break;

  case 41:
#line 600 "parser_yacc.y"
               { /* nothing */ (yyval.boolean) = 0; }
#line 2187 "parser_yacc.c"
    break;

  case 42:
#line 601 "parser_yacc.y"
                    { (yyval.boolean) = 0; }
#line 2193 "parser_yacc.c"
    break;

  case 43:
#line 602 "parser_yacc.y"
                   { (yyval.boolean) = 1; }
#line 2199 "parser_yacc.c"
    break;

  case 44:
#line 605 "parser_yacc.y"
        {
		(yyval.prefix).audit = (yyvsp[-2].boolean);
		(yyval.prefix).deny = (yyvsp[-1].boolean);
		(yyval.prefix).owner = (yyvsp[0].boolean);
	}
#line 2209 "parser_yacc.c"
    break;

  case 45:
#line 611 "parser_yacc.y"
        { /* nothing */ 
	Profile *prof = new Profile();
		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		(yyval.prof) = prof;
	}
#line 2222 "parser_yacc.c"
    break;

  case 46:
#line 620 "parser_yacc.y"
                      { /* nothing */ }
#line 2228 "parser_yacc.c"
    break;

  case 47:
#line 623 "parser_yacc.y"
        {
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		(yyvsp[0].user_entry)->deny = (yyvsp[-1].prefix).deny;
		if (((yyvsp[-1].prefix).deny && ((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) &&
		     ((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE)))
			yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));
		else if (!(yyvsp[-1].prefix).deny && ((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) &&
			 !((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE) &&
			 !((yyvsp[0].user_entry)->nt_name))
			yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', 'c', or 'u'"));

		if ((yyvsp[-1].prefix).owner == 1)
			(yyvsp[0].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
		else if ((yyvsp[-1].prefix).owner == 2)
			(yyvsp[0].user_entry)->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS);
		/* only set audit ctl quieting if the rule is not audited */
		if (((yyvsp[-1].prefix).deny && !(yyvsp[-1].prefix).audit) || (!(yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit))
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode & ~ALL_AA_EXEC_TYPE;

		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2258 "parser_yacc.c"
    break;

  case 48:
#line 651 "parser_yacc.y"
        {
		struct cod_entry *entry, *tmp;
		if ((yyvsp[-3].prefix).deny)
			yyerror(_("deny prefix not allowed"));

		PDEBUG("matched: %s%s%sblock\n", (yyvsp[-3].prefix).audit ? "audit " : "",
		       (yyvsp[-3].prefix).deny ? "deny " : "", (yyvsp[-3].prefix).owner ? "owner " : "");
		list_for_each_safe((yyvsp[-1].prof)->entries, entry, tmp) {
			entry->next = NULL;
			if (entry->mode & AA_EXEC_BITS) {
				if (entry->deny &&
				    (entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));
				else if (!entry->deny &&
					 !(entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', or 'u'"));
			}
			if ((yyvsp[-3].prefix).owner == 1)
 				entry->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
			else if ((yyvsp[-3].prefix).owner == 2)
				entry->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS);

			if ((yyvsp[-3].prefix).audit && !entry->deny)
				entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			else if (!(yyvsp[-3].prefix).audit && entry->deny)
				 entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			add_entry_to_policy((yyvsp[-4].prof), entry);
		}
		(yyvsp[-1].prof)->entries = NULL;
		// fix me transfer rules and free sub profile
		delete (yyvsp[-1].prof);
		(yyval.prof) = (yyvsp[-4].prof);
	}
#line 2296 "parser_yacc.c"
    break;

  case 49:
#line 686 "parser_yacc.y"
        {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed"));
		if (!(yyvsp[0].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[-2].prof)->alloc_net_table())
			yyerror(_("Memory allocation error."));
		list_for_each_safe((yyvsp[0].network_entry), entry, tmp) {

			/* map to extended mediation if available */
			if (entry->family == AF_UNIX && kernel_supports_unix) {
				unix_rule *rule = new unix_rule(entry->type, (yyvsp[-1].prefix).audit, (yyvsp[-1].prefix).deny);
				if (!rule)
					yyerror(_("Memory allocation error."));
				(yyvsp[-2].prof)->rule_ents.push_back(rule);
			}
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				if ((yyvsp[-1].prefix).deny) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= entry->type;
					if (!(yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= entry->type;
					if ((yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.audit[entry->family] |= entry->type;
				}
			} else {
				if ((yyvsp[-1].prefix).deny) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= 1 << entry->type;
					if (!(yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= 1 << entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= 1 << entry->type;
					if ((yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.audit[entry->family] |= 1 << entry->type;
				}
			}
			free(entry);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2347 "parser_yacc.c"
    break;

  case 50:
#line 734 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on mount rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].mnt_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].mnt_entry)->deny = 1;
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		}

		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].mnt_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2367 "parser_yacc.c"
    break;

  case 51:
#line 751 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on dbus rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].dbus_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].dbus_entry)->deny = 1;
			(yyvsp[0].dbus_entry)->audit = (yyvsp[0].dbus_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].dbus_entry)->audit = (yyvsp[0].dbus_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].dbus_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2386 "parser_yacc.c"
    break;

  case 52:
#line 767 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on signal rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].signal_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].signal_entry)->deny = 1;
			(yyvsp[0].signal_entry)->audit = (yyvsp[0].signal_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].signal_entry)->audit = (yyvsp[0].signal_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].signal_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2405 "parser_yacc.c"
    break;

  case 53:
#line 783 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on ptrace rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].ptrace_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].ptrace_entry)->deny = 1;
			(yyvsp[0].ptrace_entry)->audit = (yyvsp[0].ptrace_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].ptrace_entry)->audit = (yyvsp[0].ptrace_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].ptrace_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2424 "parser_yacc.c"
    break;

  case 54:
#line 799 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on unix rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].unix_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].unix_entry)->deny = 1;
			(yyvsp[0].unix_entry)->audit = (yyvsp[0].unix_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].unix_entry)->audit = (yyvsp[0].unix_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].unix_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2443 "parser_yacc.c"
    break;

  case 55:
#line 815 "parser_yacc.y"
        {
		PDEBUG("matched: rules change_profile\n");
		PDEBUG("rules change_profile: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `change_profile' returned NULL."));
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on unix rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].user_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].user_entry)->deny = 1;
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode;
		}
		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2466 "parser_yacc.c"
    break;

  case 56:
#line 835 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on capability rules"));

		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
			(yyvsp[-2].prof)->caps.quiet |= (yyvsp[0].cap);
		} else {
			(yyvsp[-2].prof)->caps.allow |= (yyvsp[0].cap);
			if ((yyvsp[-1].prefix).audit)
				(yyvsp[-2].prof)->caps.audit |= (yyvsp[0].cap);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2488 "parser_yacc.c"
    break;

  case 57:
#line 854 "parser_yacc.y"
        {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'hat rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2500 "parser_yacc.c"
    break;

  case 58:
#line 863 "parser_yacc.y"
        {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'local_profile rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		add_local_entry((yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2513 "parser_yacc.c"
    break;

  case 59:
#line 873 "parser_yacc.y"
        {
		PDEBUG("Matched: conditional rules\n");
		(yyval.prof) = merge_policy((yyvsp[-1].prof), (yyvsp[0].prof));
	}
#line 2522 "parser_yacc.c"
    break;

  case 60:
#line 879 "parser_yacc.y"
        {
		rlim_t value = RLIM_INFINITY;
		long long tmp;
		char *end;

		int limit = get_rlimit((yyvsp[-4].id));
		if (limit == -1)
			yyerror("INVALID RLIMIT '%s'\n", (yyvsp[-4].id));

		if (strcmp((yyvsp[-2].var_val), "infinity") == 0) {
			value = RLIM_INFINITY;
		} else {
			const char *kb = "KB";
			const char *mb = "MB";
			const char *gb = "GB";

			tmp = strtoll((yyvsp[-2].var_val), &end, 0);
			switch (limit) {
			case RLIMIT_CPU:
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				tmp = convert_time_units(tmp, SECONDS_P_MS, (yyvsp[-1].id));
				if (tmp == -1LL)
					yyerror("RLIMIT '%s %s' < minimum value of 1s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				else if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				if (!(yyvsp[-1].id))
					pwarn(_("RLIMIT 'cpu' no units specified using default units of seconds\n"));
				value = tmp;
				break;
#ifdef RLIMIT_RTTIME
			case RLIMIT_RTTIME:
				/* RTTIME is measured in microseconds */
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				tmp = convert_time_units(tmp, 1LL, (yyvsp[-1].id));
				if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id))
					pwarn(_("RLIMIT 'rttime' no units specified using default units of microseconds\n"));
				value = tmp;
				break;
#endif
			case RLIMIT_NOFILE:
			case RLIMIT_NPROC:
			case RLIMIT_LOCKS:
			case RLIMIT_SIGPENDING:
#ifdef RLIMIT_RTPRIO
			case RLIMIT_RTPRIO:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id) || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				value = tmp;
				break;
#endif
#ifdef RLIMIT_NICE
			case RLIMIT_NICE:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id))
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (tmp < -20 || tmp > 19)
					yyerror("RLIMIT '%s' out of range (-20 .. 19) %d\n", (yyvsp[-4].id), tmp);
				value = tmp + 20;
				break;
#endif
			case RLIMIT_FSIZE:
			case RLIMIT_DATA:
			case RLIMIT_STACK:
			case RLIMIT_CORE:
			case RLIMIT_RSS:
			case RLIMIT_AS:
			case RLIMIT_MEMLOCK:
			case RLIMIT_MSGQUEUE:
				if ((yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id)) {
					; /* use default of bytes */
				} else if (strstr(kb, (yyvsp[-1].id)) == kb) {
					tmp *= 1024;
				} else if (strstr(mb, (yyvsp[-1].id)) == mb) {
					tmp *= 1024*1024;
				} else if (strstr(gb, (yyvsp[-1].id)) == gb) {
					tmp *= 1024*1024*1024;
				} else {
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id));
				}
				value = tmp;
				break;
			default:
				yyerror("Unknown RLIMIT %d\n", (yyvsp[-4].id));
			}
		}
		(yyvsp[-7].prof)->rlimits.specified |= 1 << limit;
		(yyvsp[-7].prof)->rlimits.limits[limit] = value;
		free((yyvsp[-4].id));
		free((yyvsp[-2].var_val));
		(yyval.prof) = (yyvsp[-7].prof);
	}
#line 2623 "parser_yacc.c"
    break;

  case 61:
#line 978 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional rules\n");
		if ((yyvsp[-3].boolean)) {
			ret = (yyvsp[-1].prof);
		} else {
			delete (yyvsp[-1].prof);
		}
		(yyval.prof) = ret;
	}
#line 2638 "parser_yacc.c"
    break;

  case 62:
#line 990 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else rules\n");
		if ((yyvsp[-7].boolean)) {
			ret = (yyvsp[-5].prof);
			delete (yyvsp[-1].prof);
		} else {
			ret = (yyvsp[-1].prof);
			delete (yyvsp[-5].prof);
		}
		(yyval.prof) = ret;
	}
#line 2655 "parser_yacc.c"
    break;

  case 63:
#line 1004 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else-if rules\n");
		if ((yyvsp[-5].boolean)) {
			ret = (yyvsp[-3].prof);
			delete (yyvsp[0].prof);
		} else {
			ret = (yyvsp[0].prof);
			delete (yyvsp[-3].prof);
		}
		(yyval.prof) = ret;
	}
#line 2672 "parser_yacc.c"
    break;

  case 64:
#line 1018 "parser_yacc.y"
        {
		(yyval.boolean) = !(yyvsp[0].boolean);
	}
#line 2680 "parser_yacc.c"
    break;

  case 65:
#line 1023 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean  = get_boolean_var(var_name);
		PDEBUG("Matched: boolean expr %s value: %d\n", (yyvsp[0].bool_var), boolean);
		if (boolean < 0) {
			/* FIXME check for set var */
			yyerror(_("Unset boolean variable %s used in if-expression"),
				(yyvsp[0].bool_var));
		}
		(yyval.boolean) = boolean;
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2698 "parser_yacc.c"
    break;

  case 66:
#line 1038 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].set_var));
		void *set_value = get_set_var(var_name);
		PDEBUG("Matched: defined set expr %s value %lx\n", (yyvsp[0].set_var), (long) set_value);
		(yyval.boolean) = !! (long) set_value;
		free(var_name);
		free((yyvsp[0].set_var));
	}
#line 2711 "parser_yacc.c"
    break;

  case 67:
#line 1048 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean = get_boolean_var(var_name);
		PDEBUG("Matched: defined set expr %s value %d\n", (yyvsp[0].bool_var), boolean);
		(yyval.boolean) = (boolean != -1);
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2724 "parser_yacc.c"
    break;

  case 68:
#line 1057 "parser_yacc.y"
                  { (yyval.id) = (yyvsp[0].id); }
#line 2730 "parser_yacc.c"
    break;

  case 69:
#line 1058 "parser_yacc.y"
                       { (yyval.id) = (yyvsp[0].set_var); }
#line 2736 "parser_yacc.c"
    break;

  case 70:
#line 1060 "parser_yacc.y"
                          { (yyval.id) = NULL; }
#line 2742 "parser_yacc.c"
    break;

  case 71:
#line 1061 "parser_yacc.y"
                                { (yyval.id) = (yyvsp[0].id); }
#line 2748 "parser_yacc.c"
    break;

  case 72:
#line 1063 "parser_yacc.y"
                      { /* nothing */ (yyval.id) = NULL; }
#line 2754 "parser_yacc.c"
    break;

  case 73:
#line 1065 "parser_yacc.y"
        {
		(yyval.id) = (yyvsp[0].id);
	}
#line 2762 "parser_yacc.c"
    break;

  case 74:
#line 1069 "parser_yacc.y"
                { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2768 "parser_yacc.c"
    break;

  case 75:
#line 1070 "parser_yacc.y"
                    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2774 "parser_yacc.c"
    break;

  case 76:
#line 1073 "parser_yacc.y"
        {
		pwarn(_("%s: Profile abi not supported, falling back to system abi.\n"), progname);
		free((yyvsp[-1].id));
	}
#line 2783 "parser_yacc.c"
    break;

  case 77:
#line 1078 "parser_yacc.y"
               { /* nothing */ (yyval.boolean) = EXEC_MODE_EMPTY; }
#line 2789 "parser_yacc.c"
    break;

  case 78:
#line 1079 "parser_yacc.y"
                     { (yyval.boolean) = EXEC_MODE_UNSAFE; }
#line 2795 "parser_yacc.c"
    break;

  case 79:
#line 1080 "parser_yacc.y"
                   { (yyval.boolean) = EXEC_MODE_SAFE; }
#line 2801 "parser_yacc.c"
    break;

  case 80:
#line 1082 "parser_yacc.y"
          { /* nothing */ (yyval.boolean) = 0; }
#line 2807 "parser_yacc.c"
    break;

  case 81:
#line 1083 "parser_yacc.y"
                   { (yyval.boolean) = 1; }
#line 2813 "parser_yacc.c"
    break;

  case 82:
#line 1086 "parser_yacc.y"
        {
		(yyval.user_entry) = do_file_rule((yyvsp[-3].id), (yyvsp[-2].fmode), NULL, (yyvsp[-1].id));
	}
#line 2821 "parser_yacc.c"
    break;

  case 83:
#line 1091 "parser_yacc.y"
        {
		if ((yyvsp[-3].boolean) && ((yyvsp[-4].fmode) & ~AA_LINK_BITS))
			yyerror(_("subset can only be used with link rules."));
		if ((yyvsp[-1].id) && ((yyvsp[-4].fmode) & AA_LINK_BITS) && ((yyvsp[-4].fmode) & AA_EXEC_BITS))
			yyerror(_("link and exec perms conflict on a file rule using ->"));
		if ((yyvsp[-1].id) && label_contains_ns((yyvsp[-1].id)) && ((yyvsp[-4].fmode) & AA_LINK_BITS))
			yyerror(_("link perms are not allowed on a named profile transition.\n"));

		if (((yyvsp[-4].fmode) & AA_LINK_BITS)) {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fmode), (yyvsp[-1].id), NULL);
			(yyval.user_entry)->subset = (yyvsp[-3].boolean);

		} else {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fmode), NULL, (yyvsp[-1].id));
		}
 	}
#line 2842 "parser_yacc.c"
    break;

  case 84:
#line 1109 "parser_yacc.y"
        {
		char *path = strdup("/{**,}");
		int perms = ((AA_BASE_PERMS & ~AA_EXEC_TYPE) |
			     (AA_EXEC_INHERIT | AA_MAY_EXEC));
		/* duplicate to other permission set */
		perms |= perms << AA_OTHER_SHIFT;
		if (!path)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = do_file_rule(path, perms, NULL, NULL);
	}
#line 2857 "parser_yacc.c"
    break;

  case 85:
#line 1119 "parser_yacc.y"
                                  { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2863 "parser_yacc.c"
    break;

  case 86:
#line 1123 "parser_yacc.y"
        {
		if ((yyvsp[-1].boolean) != EXEC_MODE_EMPTY) {
			if (!((yyvsp[0].user_entry)->mode & AA_EXEC_BITS))
				yyerror(_("unsafe rule missing exec permissions"));
			if ((yyvsp[-1].boolean) == EXEC_MODE_UNSAFE) {
				(yyvsp[0].user_entry)->mode |= (((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) << 8) &
					 ALL_AA_EXEC_UNSAFE;
			}
			else if ((yyvsp[-1].boolean) == EXEC_MODE_SAFE)
				(yyvsp[0].user_entry)->mode &= ~ALL_AA_EXEC_UNSAFE;
		}
		(yyval.user_entry) = (yyvsp[0].user_entry);
	}
#line 2881 "parser_yacc.c"
    break;

  case 87:
#line 1138 "parser_yacc.y"
        {
		/* Oopsie, we appear to be missing an EOL marker. If we
		 * were *smart*, we could work around it. Since we're
		 * obviously not smart, we'll just punt with a more
		 * sensible error. */
		yyerror(_("missing an end of line character? (entry: %s)"), (yyvsp[-2].id));
	}
#line 2893 "parser_yacc.c"
    break;

  case 88:
#line 1147 "parser_yacc.y"
        {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[-3].id), (yyvsp[-1].id));
		entry = new_entry((yyvsp[-3].id), AA_LINK_BITS, (yyvsp[-1].id));
		entry->subset = (yyvsp[-4].boolean);
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 2906 "parser_yacc.c"
    break;

  case 89:
#line 1157 "parser_yacc.y"
        {
		size_t family;
		struct aa_network_entry *new_entry, *entry = NULL;
		for (family = AF_UNSPEC; family < get_af_max(); family++) {
			new_entry = new_network_ent(family, 0xffffffff,
						    0xffffffff);
			if (!new_entry)
				yyerror(_("Memory allocation error."));
			new_entry->next = entry;
			entry = new_entry;
		}
		(yyval.network_entry) = entry;
	}
#line 2924 "parser_yacc.c"
    break;

  case 90:
#line 1172 "parser_yacc.y"
        {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-1].id), NULL, NULL);
		if (!entry)
			/* test for short circuiting of family */
			entry = network_entry(NULL, (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2940 "parser_yacc.c"
    break;

  case 91:
#line 1185 "parser_yacc.y"
        {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-2].id), (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-2].id));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2954 "parser_yacc.c"
    break;

  case 92:
#line 1196 "parser_yacc.y"
        {
		struct cond_entry *ent;
		struct value_list *value = new_value_list((yyvsp[0].var_val));
		if (!value)
			yyerror(_("Memory allocation error."));
		ent = new_cond_entry((yyvsp[-2].id), 1, value);
		if (!ent) {
			free_value_list(value);
			yyerror(_("Memory allocation error."));
		}
		(yyval.cond_entry) = ent;
	}
#line 2971 "parser_yacc.c"
    break;

  case 93:
#line 1210 "parser_yacc.y"
        {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 1, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2983 "parser_yacc.c"
    break;

  case 94:
#line 1220 "parser_yacc.y"
        {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 0, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2995 "parser_yacc.c"
    break;

  case 95:
#line 1228 "parser_yacc.y"
           { /* nothing */ (yyval.cond_entry) = NULL; }
#line 3001 "parser_yacc.c"
    break;

  case 96:
#line 1230 "parser_yacc.y"
        {
		(yyvsp[0].cond_entry)->next = (yyvsp[-1].cond_entry);
		(yyval.cond_entry) = (yyvsp[0].cond_entry);
	}
#line 3010 "parser_yacc.c"
    break;

  case 97:
#line 1236 "parser_yacc.y"
        {
		(yyval.cond_entry_list).name = (yyvsp[-4].id);
		(yyval.cond_entry_list).list = (yyvsp[-1].cond_entry);
	}
#line 3019 "parser_yacc.c"
    break;

  case 98:
#line 1241 "parser_yacc.y"
               { /* nothing */ (yyval.cond_entry_list) = { NULL, NULL }; }
#line 3025 "parser_yacc.c"
    break;

  case 99:
#line 1242 "parser_yacc.y"
                    { (yyval.cond_entry_list) = (yyvsp[0].cond_entry_list); }
#line 3031 "parser_yacc.c"
    break;

  case 100:
#line 1245 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), (yyvsp[-1].id), NULL, NULL, AA_MAY_MOUNT);
	}
#line 3039 "parser_yacc.c"
    break;

  case 101:
#line 1250 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-5].cond_entry), (yyvsp[-4].id), (yyvsp[-2].cond_entry), (yyvsp[-1].id), AA_MAY_MOUNT);
	}
#line 3047 "parser_yacc.c"
    break;

  case 102:
#line 1255 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_DUMMY_REMOUNT);
	}
#line 3055 "parser_yacc.c"
    break;

  case 103:
#line 1260 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_MAY_UMOUNT);
	}
#line 3063 "parser_yacc.c"
    break;

  case 104:
#line 1265 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_pivot_rule((yyvsp[-3].cond_entry), (yyvsp[-2].id), (yyvsp[-1].id));
	}
#line 3071 "parser_yacc.c"
    break;

  case 105:
#line 1270 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fmode) = AA_DBUS_BIND;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_DBUS_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_DBUS_RECEIVE;
		else if (strcmp((yyvsp[0].var_val), "eavesdrop") == 0)
			(yyval.fmode) = AA_DBUS_EAVESDROP;
		else if ((yyvsp[0].var_val)) {
			parse_dbus_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3093 "parser_yacc.c"
    break;

  case 106:
#line 1287 "parser_yacc.y"
                   { (yyval.fmode) = AA_DBUS_BIND; }
#line 3099 "parser_yacc.c"
    break;

  case 107:
#line 1288 "parser_yacc.y"
                   { (yyval.fmode) = AA_DBUS_SEND; }
#line 3105 "parser_yacc.c"
    break;

  case 108:
#line 1289 "parser_yacc.y"
                      { (yyval.fmode) = AA_DBUS_RECEIVE; }
#line 3111 "parser_yacc.c"
    break;

  case 109:
#line 1290 "parser_yacc.y"
                   { (yyval.fmode) = AA_DBUS_RECEIVE; }
#line 3117 "parser_yacc.c"
    break;

  case 110:
#line 1291 "parser_yacc.y"
                    { (yyval.fmode) = AA_DBUS_SEND; }
#line 3123 "parser_yacc.c"
    break;

  case 111:
#line 1292 "parser_yacc.y"
                        { (yyval.fmode) = AA_DBUS_EAVESDROP; }
#line 3129 "parser_yacc.c"
    break;

  case 112:
#line 1294 "parser_yacc.y"
        {
		parse_dbus_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3138 "parser_yacc.c"
    break;

  case 113:
#line 1299 "parser_yacc.y"
            { /* nothing */ (yyval.fmode) = 0; }
#line 3144 "parser_yacc.c"
    break;

  case 114:
#line 1300 "parser_yacc.y"
                               { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3150 "parser_yacc.c"
    break;

  case 115:
#line 1301 "parser_yacc.y"
                                         { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3156 "parser_yacc.c"
    break;

  case 116:
#line 1303 "parser_yacc.y"
               { /* nothing */ (yyval.fmode) = 0; }
#line 3162 "parser_yacc.c"
    break;

  case 117:
#line 1304 "parser_yacc.y"
                     { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3168 "parser_yacc.c"
    break;

  case 118:
#line 1305 "parser_yacc.y"
                                                  { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3174 "parser_yacc.c"
    break;

  case 119:
#line 1308 "parser_yacc.y"
        {
		dbus_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("dbus rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new dbus_rule((yyvsp[-3].fmode), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.dbus_entry) = ent;
	}
#line 3193 "parser_yacc.c"
    break;

  case 120:
#line 1324 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "create") == 0)
			(yyval.fmode) = AA_NET_CREATE;
		else if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fmode) = AA_NET_BIND;
		else if (strcmp((yyvsp[0].var_val), "listen") == 0)
			(yyval.fmode) = AA_NET_LISTEN;
		else if (strcmp((yyvsp[0].var_val), "accept") == 0)
			(yyval.fmode) = AA_NET_ACCEPT;
		else if (strcmp((yyvsp[0].var_val), "connect") == 0)
			(yyval.fmode) = AA_NET_CONNECT;
		else if (strcmp((yyvsp[0].var_val), "shutdown") == 0)
			(yyval.fmode) = AA_NET_SHUTDOWN;
		else if (strcmp((yyvsp[0].var_val), "getattr") == 0)
			(yyval.fmode) = AA_NET_GETATTR;
		else if (strcmp((yyvsp[0].var_val), "setattr") == 0)
			(yyval.fmode) = AA_NET_SETATTR;
		else if (strcmp((yyvsp[0].var_val), "getopt") == 0)
			(yyval.fmode) = AA_NET_GETOPT;
		else if (strcmp((yyvsp[0].var_val), "setopt") == 0)
			(yyval.fmode) = AA_NET_SETOPT;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_NET_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_NET_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_net_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3231 "parser_yacc.c"
    break;

  case 121:
#line 1357 "parser_yacc.y"
                     { (yyval.fmode) = AA_NET_CREATE; }
#line 3237 "parser_yacc.c"
    break;

  case 122:
#line 1358 "parser_yacc.y"
                   { (yyval.fmode) = AA_NET_BIND; }
#line 3243 "parser_yacc.c"
    break;

  case 123:
#line 1359 "parser_yacc.y"
                     { (yyval.fmode) = AA_NET_LISTEN; }
#line 3249 "parser_yacc.c"
    break;

  case 124:
#line 1360 "parser_yacc.y"
                     { (yyval.fmode) = AA_NET_ACCEPT; }
#line 3255 "parser_yacc.c"
    break;

  case 125:
#line 1361 "parser_yacc.y"
                      { (yyval.fmode) = AA_NET_CONNECT; }
#line 3261 "parser_yacc.c"
    break;

  case 126:
#line 1362 "parser_yacc.y"
                       { (yyval.fmode) = AA_NET_SHUTDOWN; }
#line 3267 "parser_yacc.c"
    break;

  case 127:
#line 1363 "parser_yacc.y"
                      { (yyval.fmode) = AA_NET_GETATTR; }
#line 3273 "parser_yacc.c"
    break;

  case 128:
#line 1364 "parser_yacc.y"
                      { (yyval.fmode) = AA_NET_SETATTR; }
#line 3279 "parser_yacc.c"
    break;

  case 129:
#line 1365 "parser_yacc.y"
                     { (yyval.fmode) = AA_NET_GETOPT; }
#line 3285 "parser_yacc.c"
    break;

  case 130:
#line 1366 "parser_yacc.y"
                     { (yyval.fmode) = AA_NET_SETOPT; }
#line 3291 "parser_yacc.c"
    break;

  case 131:
#line 1367 "parser_yacc.y"
                   { (yyval.fmode) = AA_NET_SEND; }
#line 3297 "parser_yacc.c"
    break;

  case 132:
#line 1368 "parser_yacc.y"
                      { (yyval.fmode) = AA_NET_RECEIVE; }
#line 3303 "parser_yacc.c"
    break;

  case 133:
#line 1369 "parser_yacc.y"
                   { (yyval.fmode) = AA_NET_RECEIVE; }
#line 3309 "parser_yacc.c"
    break;

  case 134:
#line 1370 "parser_yacc.y"
                    { (yyval.fmode) = AA_NET_SEND; }
#line 3315 "parser_yacc.c"
    break;

  case 135:
#line 1372 "parser_yacc.y"
        {
		parse_unix_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3324 "parser_yacc.c"
    break;

  case 136:
#line 1377 "parser_yacc.y"
           { /* nothing */ (yyval.fmode) = 0; }
#line 3330 "parser_yacc.c"
    break;

  case 137:
#line 1378 "parser_yacc.y"
                             { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3336 "parser_yacc.c"
    break;

  case 138:
#line 1379 "parser_yacc.y"
                                       { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3342 "parser_yacc.c"
    break;

  case 139:
#line 1381 "parser_yacc.y"
              { /* nothing */ (yyval.fmode) = 0; }
#line 3348 "parser_yacc.c"
    break;

  case 140:
#line 1382 "parser_yacc.y"
                    { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3354 "parser_yacc.c"
    break;

  case 141:
#line 1383 "parser_yacc.y"
                                                 { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3360 "parser_yacc.c"
    break;

  case 142:
#line 1386 "parser_yacc.y"
        {
		unix_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("unix rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new unix_rule((yyvsp[-3].fmode), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.unix_entry) = ent;
	}
#line 3379 "parser_yacc.c"
    break;

  case 143:
#line 1402 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_MAY_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_MAY_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_signal_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3397 "parser_yacc.c"
    break;

  case 144:
#line 1415 "parser_yacc.y"
                   { (yyval.fmode) = AA_MAY_SEND; }
#line 3403 "parser_yacc.c"
    break;

  case 145:
#line 1416 "parser_yacc.y"
                      { (yyval.fmode) = AA_MAY_RECEIVE; }
#line 3409 "parser_yacc.c"
    break;

  case 146:
#line 1417 "parser_yacc.y"
                   { (yyval.fmode) = AA_MAY_RECEIVE; }
#line 3415 "parser_yacc.c"
    break;

  case 147:
#line 1418 "parser_yacc.y"
                    { (yyval.fmode) = AA_MAY_SEND; }
#line 3421 "parser_yacc.c"
    break;

  case 148:
#line 1420 "parser_yacc.y"
        {
		parse_signal_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3430 "parser_yacc.c"
    break;

  case 149:
#line 1425 "parser_yacc.y"
              { /* nothing */ (yyval.fmode) = 0; }
#line 3436 "parser_yacc.c"
    break;

  case 150:
#line 1426 "parser_yacc.y"
                                   { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3442 "parser_yacc.c"
    break;

  case 151:
#line 1427 "parser_yacc.y"
                                             { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3448 "parser_yacc.c"
    break;

  case 152:
#line 1429 "parser_yacc.y"
                 { /* nothing */ (yyval.fmode) = 0; }
#line 3454 "parser_yacc.c"
    break;

  case 153:
#line 1430 "parser_yacc.y"
                      { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3460 "parser_yacc.c"
    break;

  case 154:
#line 1431 "parser_yacc.y"
                                                    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3466 "parser_yacc.c"
    break;

  case 155:
#line 1434 "parser_yacc.y"
        {
		signal_rule *ent = new signal_rule((yyvsp[-2].fmode), (yyvsp[-1].cond_entry));
		(yyval.signal_entry) = ent;
	}
#line 3475 "parser_yacc.c"
    break;

  case 156:
#line 1440 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "trace") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_MAY_TRACE;
		else if (strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_MAY_READ;
		else if (strcmp((yyvsp[0].var_val), "tracedby") == 0)
			(yyval.fmode) = AA_MAY_TRACEDBY;
		else if (strcmp((yyvsp[0].var_val), "readby") == 0)
			(yyval.fmode) = AA_MAY_READBY;
		else if ((yyvsp[0].var_val))
			parse_ptrace_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3497 "parser_yacc.c"
    break;

  case 157:
#line 1457 "parser_yacc.y"
                    { (yyval.fmode) = AA_MAY_TRACE; }
#line 3503 "parser_yacc.c"
    break;

  case 158:
#line 1458 "parser_yacc.y"
                       { (yyval.fmode) = AA_MAY_TRACEDBY; }
#line 3509 "parser_yacc.c"
    break;

  case 159:
#line 1459 "parser_yacc.y"
                   { (yyval.fmode) = AA_MAY_READ; }
#line 3515 "parser_yacc.c"
    break;

  case 160:
#line 1460 "parser_yacc.y"
                    { (yyval.fmode) = AA_MAY_TRACE; }
#line 3521 "parser_yacc.c"
    break;

  case 161:
#line 1461 "parser_yacc.y"
                     { (yyval.fmode) = AA_MAY_READBY; }
#line 3527 "parser_yacc.c"
    break;

  case 162:
#line 1463 "parser_yacc.y"
        {
		parse_ptrace_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3536 "parser_yacc.c"
    break;

  case 163:
#line 1468 "parser_yacc.y"
              { /* nothing */ (yyval.fmode) = 0; }
#line 3542 "parser_yacc.c"
    break;

  case 164:
#line 1469 "parser_yacc.y"
                                   { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3548 "parser_yacc.c"
    break;

  case 165:
#line 1470 "parser_yacc.y"
                                             { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3554 "parser_yacc.c"
    break;

  case 166:
#line 1472 "parser_yacc.y"
                 { /* nothing */ (yyval.fmode) = 0; }
#line 3560 "parser_yacc.c"
    break;

  case 167:
#line 1473 "parser_yacc.y"
                      { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3566 "parser_yacc.c"
    break;

  case 168:
#line 1474 "parser_yacc.y"
                                                    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3572 "parser_yacc.c"
    break;

  case 169:
#line 1477 "parser_yacc.y"
        {
		ptrace_rule *ent = new ptrace_rule((yyvsp[-2].fmode), (yyvsp[-1].cond_entry));
		(yyval.ptrace_entry) = ent;
	}
#line 3581 "parser_yacc.c"
    break;

  case 170:
#line 1482 "parser_yacc.y"
                     {}
#line 3587 "parser_yacc.c"
    break;

  case 171:
#line 1483 "parser_yacc.y"
                  {}
#line 3593 "parser_yacc.c"
    break;

  case 172:
#line 1486 "parser_yacc.y"
        {
		/* A single TOK_MODE maps to the same permission in all
		 * of user::other */
		(yyval.fmode) = parse_mode((yyvsp[0].mode));
		free((yyvsp[0].mode));
	}
#line 3604 "parser_yacc.c"
    break;

  case 173:
#line 1494 "parser_yacc.y"
        {
		struct cod_entry *entry;
		int mode = AA_CHANGE_PROFILE;
		int exec_mode = (yyvsp[-3].boolean);
		char *exec = (yyvsp[-2].id);
		char *target = (yyvsp[-1].id);

		if (exec) {
			/* exec bits required to trigger rule conflict if
			 * for overlapping safe and unsafe exec rules
			 */
			mode |= AA_EXEC_BITS;
			if (exec_mode == EXEC_MODE_UNSAFE)
				mode |= ALL_AA_EXEC_UNSAFE;
			else if (exec_mode == EXEC_MODE_SAFE &&
				 !kernel_supports_stacking &&
				 warnflags & WARN_RULE_DOWNGRADED) {
				pwarn("downgrading change_profile safe rule to unsafe due to lack of necessary kernel support\n");
				/**
				 * No need to do anything because 'unsafe' exec
				 * mode is the only supported mode of
				 * change_profile rules in non-stacking kernels
				 */
			}
		} else if (exec_mode != EXEC_MODE_EMPTY)
			yyerror(_("Exec condition is required when unsafe or safe keywords are present"));
		if (exec && !(exec[0] == '/' || strncmp(exec, "@{", 2) == 0))
			yyerror(_("Exec condition must begin with '/'."));

		if (target) {
			PDEBUG("Matched change_profile: tok_id (%s)\n", target);
		} else {
			PDEBUG("Matched change_profile,\n");
			target = strdup("**");
			if (!target)
				yyerror(_("Memory allocation error."));
		}

		entry = new_entry(target, mode, exec);
		if (!entry)
			yyerror(_("Memory allocation error."));

		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 3654 "parser_yacc.c"
    break;

  case 174:
#line 1541 "parser_yacc.y"
        {
		if ((yyvsp[-1].cap) == 0) {
			/* bare capability keyword - set all caps */
			(yyval.cap) = 0xffffffffffffffff;
		} else
			(yyval.cap) = (yyvsp[-1].cap);
	}
#line 3666 "parser_yacc.c"
    break;

  case 175:
#line 1549 "parser_yacc.y"
      { /* nothing */ (yyval.cap) = 0; }
#line 3672 "parser_yacc.c"
    break;

  case 176:
#line 1551 "parser_yacc.y"
        {
		int cap = name_to_capability((yyvsp[0].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[0].id));
		free((yyvsp[0].id));
		(yyval.cap) = (yyvsp[-1].cap) | CAP_TO_MASK(cap);
	}
#line 3684 "parser_yacc.c"
    break;


#line 3688 "parser_yacc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1559 "parser_yacc.y"

#define MAXBUFSIZE 4096

void vprintyyerror(const char *msg, va_list argptr)
{
	char buf[MAXBUFSIZE];

	vsnprintf(buf, sizeof(buf), msg, argptr);

	if (profilename) {
		PERROR(_("AppArmor parser error for %s%s%s at line %d: %s\n"),
		       profilename,
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	} else {
		PERROR(_("AppArmor parser error,%s%s line %d: %s\n"),
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	}
}

void printyyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);
}

void yyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);

	exit(1);
}

struct cod_entry *do_file_rule(char *id, int mode, char *link_id, char *nt)
{
		struct cod_entry *entry;
		PDEBUG("Matched: tok_id (%s) tok_mode (0x%x)\n", id, mode);
		entry = new_entry(id, mode, link_id);
		if (!entry)
			yyerror(_("Memory allocation error."));
		entry->nt_name = nt;
		PDEBUG("rule.entry: (%s)\n", entry->name);
		return entry;
}

/* Note: NOT currently in use, used for 
 * /foo x -> { /bah, }   style transitions
 */
void add_local_entry(Profile *prof)
{
	/* ugh this has to be called after the hat is attached to its parent */
	if (prof->local_mode) {
		struct cod_entry *entry;
		char *trans = (char *) malloc(strlen(prof->parent->name) +
				    strlen(prof->name) + 3);
		char *name = strdup(prof->name);
		if (!trans)
			yyerror(_("Memory allocation error."));
		sprintf(name, "%s//%s", prof->parent->name, prof->name);

		entry = new_entry(name, prof->local_mode, NULL);
		entry->audit = prof->local_audit;
		entry->nt_name = trans;
		if (!entry)
			yyerror(_("Memory allocation error."));

		add_entry_to_policy(prof, entry);
	}
}

static const char *mnt_cond_msg[] = {"",
			 " not allowed as source conditional",
			 " not allowed as target conditional",
			 "",
			 NULL};

int verify_mnt_conds(struct cond_entry *conds, int src)
{
	struct cond_entry *entry;
	int error = 0;

	if (!conds)
		return 0;

	list_for_each(conds, entry) {
		int res = is_valid_mnt_cond(entry->name, src);
		if (res <= 0) {
				printyyerror(_("invalid mount conditional %s%s"),
					     entry->name,
					     res == -1 ? "" : mnt_cond_msg[src]);
				error++;
		}
	}

	return error;
}

mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      int mode)
{
	if (verify_mnt_conds(src_conds, MNT_SRC_OPT) != 0)
		yyerror(_("bad mount rule"));

	/* FIXME: atm conditions are not supported on dst
	if (verify_conds(dst_conds, DST_OPT) != 0)
		yyerror(_("bad mount rule"));
	*/
	if (dst_conds)
		yyerror(_("mount point conditions not currently supported"));

	mnt_rule *ent = new mnt_rule(src_conds, src, dst_conds, dst, mode);
	if (!ent) {
		yyerror(_("Memory allocation error."));
	}

	return ent;
}

mnt_rule *do_pivot_rule(struct cond_entry *old, char *root, char *transition)
{
	char *device = NULL;
	if (old) {
		if (strcmp(old->name, "oldroot") != 0)
			yyerror(_("invalid pivotroot conditional '%s'"), old->name);
		if (old->vals) {
			device = old->vals->value;
			old->vals->value = NULL;
		}
		free_cond_entry(old);
	}

	mnt_rule *ent = new mnt_rule(NULL, device, NULL, root, AA_MAY_PIVOTROOT);
	ent->trans = transition;

	return ent;
}
